﻿using UnityEngine;
using System.Collections;

public class Action
{
	public string m_actionName = "Action";
	public bool m_hasTimer = false;
	public float m_timerDuration = 1.0f;

	public bool m_enabled = true;

	public float m_currentTimer = 0.0f;
	protected bool m_active = false;

	public World m_world;

	public Cat m_cat;

	public Action(string l_name)
	{
		m_actionName = l_name;
	}
	
	public Action(string l_name, float l_timerDuration)
	{
		m_actionName = l_name;
		m_hasTimer = true;
		m_timerDuration = l_timerDuration;
	}

	public virtual void Check()
	{
		if(m_hasTimer)
		{
			if(!m_enabled)
			{
				m_currentTimer += Time.deltaTime;

				if(m_currentTimer >= m_timerDuration)
				{
					m_currentTimer = 0.0f;
					m_enabled = true;
				}
			}
			else
			{
				if(Input.GetButtonDown(m_actionName))
				{
					m_enabled = false;
					m_active = true;
				}
			}
		}
		else
		{
			if(Input.GetButtonDown(m_actionName))
			{
				m_enabled = false;
				m_active = true;
			}
		}
	}

	public virtual void Run(Animator l_animator)
	{
		if(m_active)
		{
			l_animator.SetTrigger(m_actionName);
			m_active = false;
			m_world.ActionNotification(m_actionName);
		}
	}

}
