﻿using UnityEngine;
using System.Collections;

public class Location : MonoBehaviour
{
	public int m_pointsAwarded = 1;

	public bool m_runOnce = false;
	public bool m_ran = false;

	private World m_world;

	protected Cat m_cat;
	
	protected string m_actionName;
	protected bool m_actionAwaitingProcessing = false;

	protected SpriteRenderer m_renderer;

	void Awake()
	{
		m_renderer = this.transform.Find("Icon").GetComponent<SpriteRenderer>();

		m_world = GameObject.FindGameObjectWithTag("_World").GetComponent<World>();
		m_cat = GameObject.FindGameObjectWithTag("Cat").GetComponent<Cat>();
	}
	
	void Update()
	{
	}

	public virtual void OnTriggerEnter2D(Collider2D other)
	{
		if(!m_ran)
		{
			if(other.gameObject.tag == "Cat")
			{
				StartCoroutine("FadeInIcon");
			}
		}
		else
		{
			Color c = m_renderer.color;
			c.a = 0;
			m_renderer.color = c;
		}
	}

	public virtual void OnTriggerStay2D(Collider2D other)
	{

	}

	public virtual void OnTriggerExit2D(Collider2D other)
	{
		if(!m_ran)
		{
			if(other.gameObject.tag == "Cat")
			{
				StartCoroutine("FadeOutIcon");
			}
		}
		else
		{
			Color c = m_renderer.color;
			c.a = 0;
			m_renderer.color = c;
		}
	}

	IEnumerator FadeInIcon()
	{
		for (float f = 0.0f; f <= 1.1f; f += 0.1f)
		{
			Color c = m_renderer.color;
			c.a = Mathf.Min (f,1.0f);
			m_renderer.color = c;
			yield return null;
		}
	}

	IEnumerator FadeOutIcon()
	{
		for (float f = 1.0f; f >= -0.1f; f -= 0.1f)
		{
			Color c = m_renderer.color;
			c.a = Mathf.Max (f,0.0f);
			m_renderer.color = c;
			yield return null;
		}
	}

	public void ActionNotification(string l_actionName)
	{
		m_actionName = l_actionName;
		m_actionAwaitingProcessing = true;
	}
}
