﻿using UnityEngine;
using System.Collections;

public class Menu : MonoBehaviour
{
	public GameObject m_catLeft;
	public GameObject m_catRight;
	public GameObject m_paws;
	public GameObject m_title;

	private bool m_catLeftMoving = true;
	private bool m_movingIn = true;

	public float m_catDistanceMax = 8.0f;
	public float m_catDistanceMin = 2.0f;

	public float m_transitionTime = 1.0f;
	private float m_currentTransitionTime = 0.0f;
	
	float amplitudeX = 7.5f;
	float amplitudeY = 2.0f;
	float omegaX = 1.5f;
	float omegaY = 5.0f;
	float index;

	public GUIStyle m_buttonStyle;

	void Update()
	{
		//Cats
		if(m_catLeftMoving)
		{
			m_currentTransitionTime += Time.deltaTime;

			if(m_movingIn)
			{
				m_catLeft.transform.position = Vector3.Lerp(new Vector3(-m_catDistanceMax,0,0),new Vector3(-m_catDistanceMin,0,0),m_currentTransitionTime/m_transitionTime);

				if(m_currentTransitionTime >= m_transitionTime)
				{
					m_movingIn = false;
					m_currentTransitionTime = 0.0f;
				}
			}
			else
			{
				m_catLeft.transform.position = Vector3.Lerp(new Vector3(-m_catDistanceMin,0,0),new Vector3(-m_catDistanceMax,0,0),m_currentTransitionTime/m_transitionTime);

				if(m_currentTransitionTime >= m_transitionTime)
				{
					m_movingIn = true;
					m_currentTransitionTime = 0.0f;
					m_catLeftMoving = false;
				}
			}
		}
		else
		{
			m_currentTransitionTime += Time.deltaTime;
			
			if(m_movingIn)
			{
				m_catRight.transform.position = Vector3.Lerp(new Vector3(m_catDistanceMax,0,0),new Vector3(m_catDistanceMin,0,0),m_currentTransitionTime/m_transitionTime);
				
				if(m_currentTransitionTime >= m_transitionTime)
				{
					m_movingIn = false;
					m_currentTransitionTime = 0.0f;
				}
			}
			else
			{
				m_catRight.transform.position = Vector3.Lerp(new Vector3(m_catDistanceMin,0,0),new Vector3(m_catDistanceMax,0,0),m_currentTransitionTime/m_transitionTime);
				
				if(m_currentTransitionTime >= m_transitionTime)
				{
					m_movingIn = true;
					m_currentTransitionTime = 0.0f;
					m_catLeftMoving = true;
				}
			}


		}

		// Paws
		index += Time.deltaTime * 0.025f;
		float x = amplitudeX * Mathf.Cos(omegaX * index);
		float y = Mathf.Abs(amplitudeY * Mathf.Sin (omegaY * index));
		m_paws.transform.localPosition = new Vector3(x,y,0);

		if(Input.GetKeyDown(KeyCode.Escape))
		{
			Application.Quit();
		}
	}

	void OnGUI()
	{
		float w = Screen.width / 2.0f;
		float h = Screen.height / 2.0f;

		GUIUtils.DrawButton(w,h,256,64,5,m_buttonStyle,true,"Controls");
	}
}
