﻿using UnityEngine;
using System.Collections;

public class Person : MonoBehaviour
{
	public float m_maxSpeed = 1.0f;
	public float m_movementSpeed = 365.0f;

	//public bool m_walking;
	//public bool m_standing;

	private World m_world;
	private Animator m_animator;
	private SpriteRenderer m_renderer;

	private Transform m_catTransform;

	bool m_facingRight = false;

	float m_speed = 0.0f;

	public float m_stateChangeTime = 10.0f;

	public int m_value = 0;

	void Awake()
	{
		m_world = GameObject.FindGameObjectWithTag("_World").GetComponent<World>();
		m_animator = this.GetComponent<Animator>();
		m_renderer = this.GetComponent<SpriteRenderer>();

		m_catTransform = GameObject.FindGameObjectWithTag("Cat").transform;
	}

	void Start ()
	{
		StartCoroutine("ChangeState");
	}

	void Update ()
	{
		if(m_catTransform.position.y > -0.4)
		{
			m_renderer.sortingOrder = 5;
		}
		else
		{
			m_renderer.sortingOrder = 2;
		}



	}

	IEnumerator ChangeState()
	{
		for(;;)
		{
			m_value = UnityEngine.Random.Range(0,20);

			if(m_value > 13)
			{
				m_speed = -0.5f;
			}
			else if(m_value < 7)
			{
				m_speed = 0.5f;
			}
			else
			{
				m_speed = 0.0f;
			}

			yield return new WaitForSeconds(m_stateChangeTime);
		}
	}

	void FixedUpdate()
	{
		float h = m_speed;
		
		m_animator.SetFloat("Speed",Mathf.Abs(h));
		
		if(h * this.rigidbody2D.velocity.x < m_maxSpeed)
		{
			this.rigidbody2D.AddForce(Vector2.right * h * m_movementSpeed);
		}
		
		if(Mathf.Abs(this.rigidbody2D.velocity.x) > m_maxSpeed)
		{
			this.rigidbody2D.velocity = new Vector2(Mathf.Sign(this.rigidbody2D.velocity.x) * m_maxSpeed, this.rigidbody2D.velocity.y);
		}
		
		if(h > 0 && !m_facingRight)
		{
			Flip();
		}
		else if(h < 0 && m_facingRight)
		{
			Flip();
		}
	}

	void Flip ()
	{
		m_facingRight = !m_facingRight;
		
		Vector3 l_scale = this.transform.localScale;
		l_scale.x *= -1;
		this.transform.localScale = l_scale;
	}
}
