﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class World : MonoBehaviour
{
	public GameObject m_poopObject;
	public GameObject m_barfObject;

	public List<Location> m_locations = new List<Location>();

	public List<BoxCollider2D> m_obstacles = new List<BoxCollider2D>();

	public GUIStyle m_catiitudePointsStyle;
	public GUIStyle m_notifierTextStyle;

	public Transform m_catTransform;

	public int m_totalPoints = 0;

	public string m_nextLevel = "";

	void Awake()
	{
		m_catTransform = GameObject.FindGameObjectWithTag("Cat").transform;

		GameObject[] l_objects = GameObject.FindGameObjectsWithTag("Locations");

		foreach(GameObject go in l_objects)
		{
			m_locations.Add(go.GetComponent<Location>());
		}

		l_objects = GameObject.FindGameObjectsWithTag("Obstacle");
		
		foreach(GameObject go in l_objects)
		{
			m_obstacles.Add(go.GetComponent<BoxCollider2D>());
		}
	}

	public void Update()
	{
		if(m_catTransform.GetComponent<Cat>().m_catiitudePoints >= m_totalPoints)
		{
			if(m_nextLevel != "")
			{
				Application.LoadLevel(m_nextLevel);
			}
		}

		if(Input.GetKeyDown(KeyCode.Escape))
		{
			Application.LoadLevel("Credits");
		}
	}

	public void ActionNotification(string l_name)
	{
		foreach(Location loc in m_locations)
		{
			loc.ActionNotification(l_name);
		}
	}

	public void EnableObstacles()
	{
		foreach(BoxCollider2D obs in m_obstacles)
		{
			obs.enabled = true;
		}
	}

	public void DisableObstaclesAbove()
	{
		foreach(BoxCollider2D obs in m_obstacles)
		{
			if(obs.transform.position.y > m_catTransform.position.y)
			{
				obs.enabled = false;
			}
		}
	}

	public void DisableObstaclesBelow()
	{
		foreach(BoxCollider2D obs in m_obstacles)
		{
			if(obs.transform.position.y < m_catTransform.position.y)
			{
				obs.enabled = false;
			}
		}
	}
}
